#include "LayerComposition.h"

namespace ofxVariableLab {

void LayerComposition::setup(){
    ofxMsdfgen::AtlasSettings settings;
    settings.characters = "ABCDEFGHIJKL";
    settings.scale = 64;
    //string fontName = "RobotoFlex.ttf";
    //string fontPath = "data/fonts/" + fontName;
    //string fontPath = "data/celines-fonts/testing2VF.ttf";
    string fontPath = "data/celines-fonts/Version-2-var.ttf";
    //string fontPath = "data/celines-fonts/Cottagecore.ttf";
    atlas.setup(fontPath, settings);

    atlasImage = make_shared <ofImage>(atlas.getAtlasImage());
    glyphGeometries = atlas.getGlyphGeometries();
    msdfShader = make_shared <ofShader>();
    #ifdef TARGET_EMSCRIPTEN
        msdfShader->load("ofxMsdfgen/shaders/unitRange/ES3/shader");
    #else
        shader->load("ofxMsdfgen/shaders/unitRange/GL3/shader");
    #endif

    auto layer = make_unique <ofxVariableLab::MsdfLayer>();
    layer->atlasImage = atlasImage;
    layer->shader = msdfShader;
    layer->atlasImage->update();

    layers.push_back(std::move(layer));
}

void LayerComposition::update(){
}

void LayerComposition::draw() const {
    //ofClear(ofFloatColor(
    //ofRandom(0, 1),
    //ofRandom(0, 1),
    //ofRandom(0, 1)
    //));
    for(const auto & layer : layers){
        layer->draw();
    }
    ofPushStyle();
    ofPopStyle();
}

shared_ptr <ofImage> LayerComposition::getAtlasImage(){
    return atlasImage;
}

}
